import { createSlice } from '@reduxjs/toolkit';

const initialState = {
    todoList: [
        {
            name: 'book ticket',
            id: 0,
            isCompleted: false,
            isDeleted: false
        }
    ],
    id: 0,
    isNew: true, // this flag is used to enable/disable New Button
    isEdit: false, // if this flag is enable then user is editing existing todo or else user is creating new todo
    isInput: false, // this flag is used to enable/disable input field
    inputValue: '', 
    todoId: ''
};

export const todoSlice = createSlice({
    name: 'todos',
    initialState,
    // The `reducers` field lets us define reducers and generate associated actions
    reducers: {
        updateInputValue: (state, action) => {
            state.inputValue = action.payload

            return state;
        },
        add: (state, action) => { // create todo
            // Redux Toolkit allows us to write "mutating" logic in reducers. It
            // doesn't actually mutate the state because it uses the Immer library,
            // which detects changes to a "draft state" and produces a brand new
            // immutable state based off those changes
            // Use the PayloadAction type to declare the contents of `action.payload`
            state.todoList.push({ name: action.payload.name, id: state.id += 1 })
            state.isInput = false
            state.isNew = true

            return state;
        },
        activateEdit: (state) => { // enable input field with no data
            state.isInput = true
            state.isNew = false
            state.isEdit = false

            return state;
        },
        activateEditWithValue: (state, action) => { // enable input field with todo name 
            state.isInput = true
            state.isEdit = true
            state.isNew = false
            state.inputValue = action.payload.name
            state.todoId = action.payload.id

            return state;
        },
        edit: (state, action) => { // update todo
            const objIndex = state.todoList.findIndex((todo => todo.id === action.payload.id));
            if (objIndex > -1) {
                state.todoList[objIndex].name = action.payload.name
            } else {
                console.log(objIndex)
            }
            state.isInput = false
            state.inNew = true
            state.isNew = true;

            return state;
        },
        removeTodo: (state, action) => { // delete todo
            const objIndex = state.todoList.findIndex((todo => todo.id === action.payload));
            if (objIndex > -1) {
                state.todoList.splice(objIndex, 1)
            }

            state.isNew = true;
            return state;
        },
        markAsComplete: (state, action) => { // mark todo as complete
            const objIndex = state.todoList.findIndex((todo => todo.id === action.payload));
            debugger
            if (objIndex > -1) {
                state.todoList[objIndex].isCompleted = true
            }

            state.isNew = true;
            return state;
        },
        clearState: (state) => {
            state.isNew = true;
            state.isEdit = false;
            state.isInput = false;

            return state;
        },
    },
    // The `extraReducers` field lets the slice handle actions defined elsewhere,
    // including actions generated by createAsyncThunk or in other slices.
    extraReducers: (builder) => {
    },
});

export const { add, edit, removeTodo, activateEdit, activateEditWithValue, updateInputValue, clearState, markAsComplete } = todoSlice.actions;

export const selectTodos = state => state.todos

export default todoSlice.reducer;